"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var FieldsTree = /** @class */ (function () {
    function FieldsTree() {
        this._fields = {};
    }
    FieldsTree.prototype.addField = function (path, type) {
        lodash_1.set(this._fields, path, type);
    };
    FieldsTree.prototype._getInnerField = function (root, level) {
        var _this = this;
        if (level === void 0) { level = 1; }
        if (typeof root === 'string') {
            return root;
        }
        var fields = Object.keys(root).map(function (fieldName) {
            var fieldValue = root[fieldName];
            return graphql_codegen_visitor_plugin_common_1.indent(fieldName + ": " + _this._getInnerField(fieldValue, level + 1) + ",", level);
        });
        return level === 1
            ? fields.join('\n')
            : "{\n" + fields.join('\n') + "\n" + graphql_codegen_visitor_plugin_common_1.indent('}', level - 1);
    };
    Object.defineProperty(FieldsTree.prototype, "string", {
        get: function () {
            return this._getInnerField(this._fields);
        },
        enumerable: true,
        configurable: true
    });
    return FieldsTree;
}());
exports.FieldsTree = FieldsTree;
//# sourceMappingURL=fields-tree.js.map